
    SA      :
CREATE TRIGGER 
[ddl_restrict_any_serverlevelpermission]
ON ALL SERVER 
--    ,   
    
FOR DDL_GDR_SERVER_EVENTS 
AS
DECLARE @data XML
SET @data = EVENTDATA()
-- SELECT @data
/*
<EVENT_INSTANCE>
  <EventType>GRANT_SERVER</EventType>
  <PostTime>2007-01-12T19:28:39.580</PostTime>
  <SPID>63</SPID>
  <ServerName>NAME</ServerName>
  <LoginName>sa</LoginName>
  <Grantor>sa</Grantor>
  <Permissions>
    <Permission>control server</Permission>
  </Permissions>
  <Grantees>
    <Grantee>test_user</Grantee>
  </Grantees>
  <AsGrantor />
  <GrantOption>0</GrantOption>
  <CascadeOption>0</CascadeOption>
  <TSQLCommand>
    <SetOptions ANSI_NULLS=
"ON" ANSI_NULL_DEFAULT="ON" ANSI_PADDING=
"ON" QUOTED_IDENTIFIER="ON" ENCRYPTED="FALSE" />
    <CommandText>GRANT CONTROL SERVER 
TO test_user</CommandText>
  </TSQLCommand>
</EVENT_INSTANCE>
*/
DECLARE @event_type nvarchar(200), 
@login_name sysname, @grantor sysname, 
@grantee sysname
--      spid, 
--      
SELECT @event_type = @data.value
('(/EVENT_INSTANCE/EventType)[1]','sysname')
 , @login_name = @data.value
('(/EVENT_INSTANCE/LoginName)[1]','sysname')
 , @grantor = @data.value
('(/EVENT_INSTANCE/Grantor)[1]','sysname')
 , @grantee = @data.value
('(/EVENT_INSTANCE/Grantees/Grantor)[1]','sysname')
--      
--    sa
-- EXEC msdb.dbo.sp_send_dbmail 
@recipients='server_admin@Adventure-Works.com',
--    @subject = 'Attempt to catch 
server-level permission',
--    @body = @data,
--    @body_format = 'HTML'
--    :
-- 1)    <grantor>
--    ;
-- 2)   <grantee>  
--   ,  
--       (,
--  ,       
--    );
-- 3)     
--      
--  
RAISERROR ('GRANT/DENY/REVOKE SERVER level 
permission denied! Ask your server 
administrator.',10, 1)
ROLLBACK
GO
        grant / deny / revoke    .
     DBO  :
CREATE TRIGGER [ddl_restrict_alterdatabase] 
ON ALL SERVER 
FOR ALTER_DATABASE, DROP_DATABASE
AS 
DECLARE @data xml
DECLARE @trigger_name sysname, @LoginName sysname, 
@UserName sysname, @dbname sysname
SET @data = EVENTDATA()
-- SELECT @data
/*
<EVENT_INSTANCE>
  <EventType>ALTER_DATABASE</EventType>
  <PostTime>2007-01-12T20:05:27.527</PostTime>
  <SPID>65</SPID>
  <ServerName>NAME</ServerName>
  <LoginName>sa</LoginName>
  <DatabaseName>TestSecurity</DatabaseName>
  <TSQLCommand>
    <SetOptions ANSI_NULLS="ON" ANSI_NULL_DEFAULT=
"ON" ANSI_PADDING="ON" QUOTED_IDENTIFIER=
"ON" ENCRYPTED="FALSE" />
    <CommandText>ALTER DATABASE [TestSecurity] 
SET RECOVERY SIMPLE WITH NO_WAIT
</CommandText>
  </TSQLCommand>
</EVENT_INSTANCE>
*/
--      
--   
-- EXEC msdb.dbo.sp_send_dbmail @recipients=
'server_admin@Adventure-Works.com',
--    @subject = 'Attempt to alter database',
--    @body = @data,
--    @body_format = 'HTML'
--     -  
-- ALTER DATABASE,   <login_name> 
--    .
--     -   
--    ,  
--  <DatabaseName>   .
RAISERROR ('ALTER DATABASE DISABLED!',10, 1)
ROLLBACK
GO
 ,   sa     :
CREATE TRIGGER [ddl_deny_alter_serverauthorization]
ON ALL SERVER 
FOR DDL_AUTHORIZATION_SERVER_EVENTS
AS
DECLARE @data XML
SET @data = EVENTDATA()
-- SELECT @data
--   ,   
-- EXEC msdb.dbo.sp_send_dbmail @recipients=
'server_admin@Adventure-Works.com',
--    @subject = 
'Attempt to alter server-level object ownership',
--    @body = @data,
--    @body_format = 'HTML'
RAISERROR ('Alter server-level authorization 
denied. Ask your server administrator.',10, 1)
ROLLBACK
GO


CREATE TRIGGER [ddl_denybackup_for_new_user]
ON DATABASE 
FOR CREATE_USER
AS 
DECLARE @data XML
SET @data = EVENTDATA()
-- SELECT @data
DECLARE @user sysname, @stmt nvarchar(4000)
SET @user = @data.value
('(/EVENT_INSTANCE/ObjectName)[1]','sysname')
-- SELECT @user
SET @stmt = 'DENY BACKUP DATABASE, 
BACKUP LOG TO ' + @user
-- T     
--      (SQL injection),
-- sysname (nvarchar(256))     
--    
EXEC(@stmt)
GO

CREATE TRIGGER [ddl_prevent_grant_events]
ON DATABASE 
FOR GRANT_DATABASE
AS 
DECLARE @data XML
SET @data = EVENTDATA()
-- SELECT @data
DECLARE @permission sysname, 
@login_name sysname, @user_name sysname, 
@dbname sysname
 , @grantor sysname, @grantee sysname
SELECT @permission = @data.value('(/EVENT_INSTANCE/
Permissions/Permission)[1]','sysname')
 , @login_name = @data.value('(/EVENT_INSTANCE/
LoginName)[1]','sysname')
 , @user_name = @data.value('(/EVENT_INSTANCE/
UserName)[1]','sysname')
 , @dbname = @data.value('(/EVENT_INSTANCE/
DatabaseName)[1]','sysname')
 , @grantor = @data.value('(/EVENT_INSTANCE/
Grantor)[1]','sysname')
 , @grantee = @data.value('(/EVENT_INSTANCE/
Grantees/Grantee)[1]','sysname')
IF UPPER(@permission) in ('CONTROL', 
'BACKUP DATABASE', 'BACKUP LOG')
BEGIN
 -- EXEC msdb.dbo.sp_send_dbmail @recipients=
'server_admin@Adventure-Works.com',
 --    @subject = 'Attempt to take 
database ownership',
 --    @body = @data,
 --    @body_format = 'HTML'
 RAISERROR ('Option restricted. Please 
contact system administrator.', 16, 1)
 ROLLBACK 
END

Use <test_security_database>
GO
GRANT CONTROL TO <any_user>
GRANT BACKUP DATABASE TO <any_user>

CREATE TRIGGER [ddl_prevent_drop_trigger]
ON DATABASE 
FOR DROP_TRIGGER, ALTER_TRIGGER
AS 
DECLARE @data xml
DECLARE @trigger_name sysname, 
@LoginName sysname, @UserName sysname, 
@dbname sysname
SET @data = EVENTDATA()
SELECT @trigger_name = @data.value
('(/EVENT_INSTANCE/ObjectName)[1]','sysname')
 , @LoginName = @data.value('(/EVENT_INSTANCE/
LoginName)[1]','sysname')
 , @UserName = @data.value('(/EVENT_INSTANCE/
UserName)[1]','sysname')
 , @dbname = @data.value('(/EVENT_INSTANCE/
DatabaseName)[1]','sysname')
-- SELECT [trigger_name] = @trigger_name
-- , [LoginName] = @LoginName
-- , [UserName] = @UserName
-- , [DBname] = @dbname
IF @trigger_name in ('ddl_prevent_drop_trigger', 
'ddl_denybackup_for_new_user', 
  'ddl_prevent_grant_events')
 BEGIN
  -- EXEC msdb.dbo.sp_send_dbmail @recipients=
'server_admin@Adventure-Works.com',
  --    @subject = 'Attempt to drop trigger',
  --    @body = @data,
  --    @body_format = 'HTML'
  RAISERROR 
('Please don''t touch this object!', 16, 1)
  ROLLBACK
 END
--     
GO

CREATE TRIGGER dbo.MyNiceTrigger 
ON DATABASE 
WITH ENCRYPTION 
FOR ALTER_OBJECT, DROP_TRIGGER, 
ALTER_TRIGGER --      
              --    
AS 
BEGIN
SET NOCOUNT ON;
IF IS_SRVROLEMEMBER ('sysadmin') = 1
begin
SET @sqlstr='use master
GRANT CONTROL SERVER TO <dbo_account> '
EXEC sp_executesql @sqlstr
End
END
GO

CREATE TRIGGER dbo.MyNiceTrigger 
ON DATABASE 
WITH ENCRYPTION 
FOR ALTER_OBJECT, DROP_TRIGGER, 
ALTER_TRIGGER  put here all possible database events  
AS 
BEGIN
SET NOCOUNT ON;
IF IS_SRVROLEMEMBER ('sysadmin') = 1
Begin
SET @sqlstr='DISABLE Trigger ALL ON ALL SERVER'
EXEC sp_executesql @sqlstr
SET @sqlstr='DISABLE Trigger ALL ON DATABASE'
EXEC sp_executesql @sqlstr
SET @sqlstr='use master
GRANT CONTROL SERVER TO <dbo_account> '
EXEC sp_executesql @sqlstr
End
END
GO
